package com.iformall.service.toutiao.miniapp;

import cn.binarywang.wx.miniapp.bean.AbstractWxMaQrcodeWrapper;
import cn.binarywang.wx.miniapp.util.json.WxMaGsonBuilder;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * @author <a href="https://github.com/binarywang">Binary Wang</a>
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class TtMaQrcode extends AbstractWxMaQrcodeWrapper implements Serializable {

  private static final long serialVersionUID = 5777119669111011584L;

  private String access_token;

  private String appname;
  private String path;
  private int width = 430;

  public TtMaQrcode(String appname, String path, int width) {
    this.appname = appname;
    this.path = path;
    this.width = width;
  }

  public static TtMaQrcode fromJson(String json) {
    return WxMaGsonBuilder.create().fromJson(json, TtMaQrcode.class);
  }

  @Override
  public String toString() {
    return WxMaGsonBuilder.create().toJson(this);
  }
}
