package com.iformall.service.wechat.handler;

import com.iformall.domain.po.WxAuthorizerInfo;
import com.iformall.mapper.WxAuthorizerInfoMapper;
import com.iformall.service.WxCUserService;
import com.iformall.service.wechat.handler.AbstractHandler;
import me.chanjar.weixin.common.session.WxSessionManager;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @author Stormeye Wu
 */
@Component
public class UnsubscribeHandler extends AbstractHandler {

    @Autowired
    private WxAuthorizerInfoMapper wxAuthorizerInfoMapper;

    @Autowired
    private WxCUserService userService;

    @Override
    public WxMpXmlOutMessage handle(WxMpXmlMessage wxMessage,
                                    Map<String, Object> context, WxMpService wxMpService,
                                    WxSessionManager sessionManager) {
        String appId = wxMpService.getWxMpConfigStorage().getAppId();
        String openId = wxMessage.getFromUser();
        this.logger.info("取消关注用户 OPENID: " + openId+ ", AppId: " + appId);

        WxAuthorizerInfo authQ = new WxAuthorizerInfo();
        authQ.setAuthorizerAppid(appId);
        WxAuthorizerInfo authorizerInfo = wxAuthorizerInfoMapper.findWeChatMp(authQ);
        if(authorizerInfo == null) {
            return null;
        }
        WxMpUser mpUser = new WxMpUser();
        mpUser.setOpenId(wxMessage.getFromUser());
        mpUser.setSubscribe(false);
        mpUser.setSubscribeTime(wxMessage.getCreateTime());

        userService.saveOrUpdateMpUser(mpUser, authorizerInfo);
        return null;
    }

}
