package com.iformall.controller;

import com.github.pagehelper.PageInfo;
import com.iformall.common.ErrorCode;
import com.iformall.common.ResultData;
import com.iformall.controller.base.BaseController;
import com.iformall.domain.po.WxWeappBasicSet;
import com.iformall.service.WxWeappBasicSetService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

/**
 * Stormeye Wu
 */
@Controller
@RequestMapping("/weappBasicSet")
@Api(description = "小程序基础设置接口")
public class WxWeappBasicSetController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private Integer getFmDeploy;

    @Autowired
    private WxWeappBasicSetService weappBasicSetService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxWeappBasicSet weappBasicSet, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxWeappBasicSetController::list");
        if (null == weappBasicSet) weappBasicSet = new WxWeappBasicSet();
        weappBasicSet.setDeploy(getFmDeploy);
        final PageInfo<WxWeappBasicSet> page = weappBasicSetService.listAsPage(weappBasicSet, pageNum, pageSize);
        return new ResultData(page);
    }

    @PostMapping("add")
    public ResultData add(WxWeappBasicSet weappBasicSet) {
        logger.debug("[" + getIpAddr() + "] WxWeappBasicSetController::add");
        if (null == weappBasicSet) return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL);
        weappBasicSetService.saveOrUpdate(weappBasicSet);
        return new ResultData();
    }

    @PostMapping("update")
    public ResultData update(WxWeappBasicSet weappBasicSet) {
        logger.debug("[" + getIpAddr() + "] WxWeappBasicSetController::update");
        if (null == weappBasicSet) return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL);
        weappBasicSetService.saveOrUpdate(weappBasicSet);
        return new ResultData();
    }

}
